SDL_LoadWAV_IO(3)

NAME
SDL_LoadWAV_IO - Load the audio data of a WAVE file into memory.

SYNOPSIS
#include <SDL3/SDL_audio.h>

bool SDL_LoadWAV_IO(SDL_IOStream *src, bool closeio, SDL_AudioSpec *spec, Uint8 **audio_buf, Uint32 *audio_len);

DESCRIPTION
Loading a WAVE file requires src,

spec,

audio_buf and audio_len to be valid pointers. The entire data portion of the file is then loaded into memory and decoded if necessary.

Supported formats are RIFF WAVE files with the formats PCM (8, 16, 24, and 32 bits), IEEE Float (32 bits), Microsoft ADPCM and IMA ADPCM (4 bits), and A-law and mu-law (8 bits). Other formats are currently unsupported and cause an error.

If this function succeeds, the return value is zero and the pointer to the audio data allocated by the function is written to audio_buf and its length in bytes to audio_len. The SDL_AudioSpec members freq,

channels, and format are set to the values of the audio data in the buffer.

It's necessary to use SDL_free() to free the audio data returned in audio_buf when it is no longer used.

Because of the underspecification of the .WAV format, there are many problematic files in the wild that cause issues with strict decoders. To provide compatibility with these files, this decoder is lenient in regards to the truncation of the file, the fact chunk, and the size of the RIFF chunk. The hints SDL_HINT_WAVE_RIFF_CHUNK_SIZE, SDL_HINT_WAVE_TRUNCATION, and SDL_HINT_WAVE_FACT_CHUNK can be used to tune the behavior of the loading process.

Any file that is invalid (due to truncation, corruption, or wrong values in the headers), too big, or unsupported causes an error. Additionally, any critical I/O error from the data source will terminate the loading process with an error. The function returns NULL on error and in all cases (with the exception of src being NULL), an appropriate error message will be set.

It is required that the data source supports seeking.

Example:

        SDL_LoadWAV_IO(SDL_IOFromFile("sample.wav", "rb"), true, &spec, &buf, &len);

Note that the SDL_LoadWAV function does this same thing for you, but in a less messy way:

        SDL_LoadWAV("sample.wav", &spec, &buf, &len);

FUNCTION PARAMETERS

src the data source for the WAVE data.

closeio
    if true, calls SDL_CloseIO() on src before returning, even in the case of an error.

spec
    a pointer to an SDL_AudioSpec that will be set to the WAVE data's format details on successful return.

audio_buf
    a pointer filled with the audio data, allocated by the function.

audio_len
    a pointer filled with the length of the audio data buffer in bytes.

RETURN VALUE
for more information.

When the application is done with the data returned in audio_buf, it should call SDL_free() to dispose of it.

THREAD SAFETY
It is safe to call this function from any thread.

AVAILABILITY
This function is available since SDL 3.2.0.

SEE ALSO
SDL_free(3), SDL_LoadWAV(3)